create or replace
PROCEDURE ETL_DROSAP
                           (P_DTINI IN DATE,
                            P_DTFIM IN DATE)
IS
   V_DTINI   DATE;
   V_DTFIM   DATE;

   V_FATLIQ_MEDICAO     FLOAT NOT NULL := 0;
   V_FATLIQ_NF          FLOAT NOT NULL := 0;
   V_FATMEDICAO         FLOAT NOT NULL := 0;
   V_FATNOTAFISCAL      FLOAT NOT NULL := 0;
   V_DESPESASDIVER      FLOAT NOT NULL := 0;
   V_DESPESAMAO         FLOAT NOT NULL := 0;
   
   V_IMPOSTO_FAT_MED    FLOAT NOT NULL := 0;
   V_IMPOSTO_FAT_NF     FLOAT NOT NULL := 0;

   V_VRCONSUMOTOTAL     FLOAT NOT NULL := 0;
   V_DESPESAENTRA       FLOAT NOT NULL := 0;
   V_VRTXTAR            FLOAT;
   V_VRTXTAC            FLOAT;
   V_CDAREAGERE         VARCHAR2(3);

   V_TIPOFATU           VARCHAR2(30);

   V_ANO                VARCHAR2(04);
   V_MES                VARCHAR2(02);
   V_TRI                VARCHAR2(10);
   V_BIM                VARCHAR2(10);
   V_SEM                VARCHAR2(10);

   V_ZERO               NUMBER :=0;
   V_CONT               NUMBER :=0;
BEGIN

   V_MES := TO_CHAR(P_DTINI,'MM');
   V_ANO := TO_CHAR(P_DTINI,'YYYY');

   DELETE FROM ETLDRO
   WHERE (ANETLDRO > V_ANO)
   OR   (ANETLDRO = V_ANO AND MEETLDRO >= V_MES);
   COMMIT;

   V_DTINI := TO_DATE('01'||TO_CHAR(P_DTINI,'MMYYYY'),'DDMMYYYY');
   WHILE (V_DTINI <= P_DTFIM)
   LOOP
      V_DTFIM := LAST_DAY(V_DTINI);
      V_ANO :=  TO_CHAR(V_DTFIM,'YYYY');
      V_MES :=  TO_CHAR(V_DTFIM,'MM');
      V_BIM :=  TO_CHAR(TRUNC((V_MES - 1) / 2) + 1)||' Bim';
      V_TRI :=  TO_CHAR(TRUNC((V_MES - 1) / 3) + 1)||' Tri';
      V_SEM :=  TO_CHAR(TRUNC((V_MES - 1) / 6) + 1)||' Sem';

      FOR C_ETL IN
         (SELECT
                F.CDFILIAL,        F.CDAREAGERE,        F.CDSEGMER,
                F.CDEMPRESA,       F.CDSUPERVISOR,      F.DTINICIALBI,
                F.CDGOPERAC,       PF.CDTIPOFATUR
          FROM
                FILIAL F, PARAMFILIAL PF
          WHERE
                F.CDFILIAL = PF.CDFILIAL
           AND  F.IDFUNCAOFILI IS NULL
          AND   F.DTINICIALBI IS NOT NULL
          AND   PF.CDTIPOFATUR IS NOT NULL
         )
      LOOP
      
         IF ADD_MONTHS(LAST_DAY(C_ETL.DTINICIALBI) + 1 , -1) <= V_DTINI THEN
         
         --____________________________ IMPOSTOS ________________________________--

               
                         ---IMPOSTOS FATARUMANETO MEDIO---
                  BEGIN                         
                  
                         SELECT 
                              SUM(VRITRELITROP) VRTOTRELITROP
                           INTO
                            V_IMPOSTO_FAT_MED
                           FROM
                              LANCROPFILIAL L, 
                              ITLANCROPFILIAL IT, ITRELACITROP IR
                           WHERE
                                (L.CDFILIAL      = C_ETL.CDFILIAL)  
                           AND l.IDTPLANCROP IN ('FE')
                           AND  (L.CDFILIAL      = IT.CDFILIAL    )
                           AND  (L.NRROPFILIAL   = IT.NRROPFILIAL )
                           AND  (L.NRLANCROP     = IT.NRLANCROP   )
                           AND  (IT.CDFILIAL     = IR.CDFILIAL    )
                           AND  (IT.NRROPFILIAL  = IR.NRROPFILIAL )
                           AND  (IT.NRLANCROP    = IR.NRLANCROP   )
                           AND  (IT.NRITLANCROP  = IR.NRITLANCROP )
                           AND  (L.DTLANCROP  BETWEEN V_DTINI AND V_DTFIM );
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_IMPOSTO_FAT_MED := V_ZERO;
                  END;
               
               
                        ---IMPOSTOS FATARUMANETO NOTAS FISCAIS---
               
                BEGIN                         
                  
                         SELECT 
                              SUM(VRITRELITROP) VRTOTRELITROP
                           INTO
                            V_IMPOSTO_FAT_NF
                           FROM
                              LANCROPFILIAL L, 
                              ITLANCROPFILIAL IT, ITRELACITROP IR
                           WHERE
                                (L.CDFILIAL      = C_ETL.CDFILIAL)  
                           AND l.IDTPLANCROP IN ('FS')
                           AND  (L.CDFILIAL      = IT.CDFILIAL    )
                           AND  (L.NRROPFILIAL   = IT.NRROPFILIAL )
                           AND  (L.NRLANCROP     = IT.NRLANCROP   )
                           AND  (IT.CDFILIAL     = IR.CDFILIAL    )
                           AND  (IT.NRROPFILIAL  = IR.NRROPFILIAL )
                           AND  (IT.NRLANCROP    = IR.NRLANCROP   )
                           AND  (IT.NRITLANCROP  = IR.NRITLANCROP )
                           AND  (L.DTLANCROP  BETWEEN V_DTINI AND V_DTFIM );
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_IMPOSTO_FAT_NF := V_ZERO;
                  END;
                 
               
               
 --_______________________________________________________________--
                          ---DESPESAS---
               BEGIN
                                       
                SELECT 
                      SUM(NVL(DECODE(IDTPLANCROP, 'DD',VRITEMLANCROP,0),0)) AS  VRDESPESADIVER,
                      SUM(NVL(DECODE(IDTPLANCROP, 'DE',VRITEMLANCROP,0),0)) AS  VRDESPESAENTRA,
                      SUM(NVL(DECODE(IDTPLANCROP, 'DM',VRITEMLANCROP,0),0)) AS  VRDESPESAMAO,
                      SUM(NVL(DECODE(IDTPLANCROP, 'FS',VRITEMLANCROP,0),0)) AS  VRFATNOTAFISCAL,
                      SUM(NVL(DECODE(IDTPLANCROP, 'FE',VRITEMLANCROP,0),0)) AS  VRFATMEDICAO,
                      SUM(NVL(DECODE(IDTPLANCROP, 'RE',VRITEMLANCROP,'RP',VRITEMLANCROP, 0),0)) AS  VRDESPESARET
                 INTO
                       V_DESPESASDIVER  , 
                       V_DESPESAENTRA   , 
                       V_DESPESAMAO     ,
                       V_FATNOTAFISCAL  ,
                       V_FATMEDICAO     ,
                       V_VRCONSUMOTOTAL
                 FROM 
                      ITLANCROPFILIAL IT, LANCROPFILIAL L
                WHERE
                      (L.CDFILIAL       = C_ETL.CDFILIAL)
                 AND  (L.IDTPLANCROP    IN ('DD','DE','DM','RE','RP','FS','FE'))
                 AND  (L.CDFILIAL       = IT.CDFILIAL   )
                 AND  (L.NRROPFILIAL    = IT.NRROPFILIAL)
                 AND  (L.NRLANCROP      = IT.NRLANCROP  )
                 AND  (L.DTLANCROP  BETWEEN V_DTINI AND V_DTFIM);
                         
               EXCEPTION
                  WHEN OTHERS THEN
                     V_DESPESASDIVER := V_ZERO;
                     V_DESPESAENTRA  := V_ZERO;
                     V_DESPESAMAO    := V_ZERO;
                     V_VRCONSUMOTOTAL:= V_ZERO;
               END;

  --____________________________________________________________________--
 
  --____________________________________________________________________--
                       --TAXA DO TAR E DO TAC--     
                           
                  SELECT CDAREAGERE
                    INTO V_CDAREAGERE
                    FROM FILIAL
                  WHERE CDFILIAL = C_ETL.CDFILIAL
                    AND CDEMPRESA = C_ETL.CDEMPRESA;
                                     
                     SELECT NVL(MAX(VRTXDESPREGE),0)
                       INTO V_VRTXTAR
                       FROM TXDESPREGE
                     WHERE CDAREAGERE = V_CDAREAGERE
                       AND DTTXDESPREGE = V_DTINI;
                 
                      IF V_VRTXTAR = 0 THEN                                                                                                                                                                                                             
                         SELECT NVL(MAX(VRTXDESPREGE),0)                                                                                                                                                                                                   
                           INTO V_VRTXTAR                                                                                                                                                                                                               
                           FROM TXDESPREGE                                                                                                                                                                                                                 
                         WHERE CDAREAGERE = V_CDAREAGERE                                                                                                                                                                                                  
                           AND DTTXDESPREGE = ADD_MONTHS(V_DTINI, -1);                                                                                                                                                                                    
                      END IF; 
                                         
                          SELECT NVL(MAX(VRTXDESPREGE),0)
                            INTO V_VRTXTAC
                            FROM TXDESPREGE T, FILIAL FL, OPERADOR O
                          WHERE T.CDAREAGERE = FL.CDAREAGERE
                            AND FL.CDSUPERVISOR = O.CDOPERADOR
                            AND O.NMOPERADOR = 'TAC'
                            AND DTTXDESPREGE = V_DTINI;
                  
                          IF V_VRTXTAC = 0 THEN
                           SELECT NVL(MAX(VRTXDESPREGE),0)
                             INTO V_VRTXTAC
                             FROM TXDESPREGE T, FILIAL FL, OPERADOR O
                           WHERE T.CDAREAGERE = FL.CDAREAGERE
                             AND FL.CDSUPERVISOR = O.CDOPERADOR
                             AND O.NMOPERADOR = 'TAC'
                             AND DTTXDESPREGE = ADD_MONTHS(V_DTINI, -1);
                          END IF;

                      
              
  --____________________________________________________________________--
              
              --CALCULO VALOR TOTAL DO FATURAMENTO LIQUIDO-- 
               V_FATLIQ_MEDICAO := (V_FATMEDICAO - V_IMPOSTO_FAT_MED); 
               V_FATLIQ_NF := (V_FATNOTAFISCAL - V_IMPOSTO_FAT_NF);
               

             -- Atencao!!! Nao usar estrutura CASE, devido a compatibilidade com Oracle 8
              IF C_ETL.CDTIPOFATUR    = '001' THEN V_TIPOFATU := 'Gesto Direta';
                 ELSIF C_ETL.CDTIPOFATUR = '003'  THEN V_TIPOFATU :=  'Mandato';
                    ELSIF C_ETL.CDTIPOFATUR = '004'  THEN  V_TIPOFATU :=  'Refeies e Servicos';
                       ELSIF C_ETL.CDTIPOFATUR = '005'  THEN  V_TIPOFATU :=  'Taxa Fixa';
                          ELSIF C_ETL.CDTIPOFATUR = '006'  THEN  V_TIPOFATU :=  'Gesto Hospitalar';
                             ELSIF C_ETL.CDTIPOFATUR = '007'  THEN  V_TIPOFATU := 'Produtos e Servios';
                                ELSIF C_ETL.CDTIPOFATUR = '008'  THEN  V_TIPOFATU := 'Produtos e Servios';
                                   ELSE V_TIPOFATU := 'Sem Tipo Faturamento';
               END IF;

               INSERT INTO ETLDRO
                        (
                          CDFILIAL            ,   CDEMPRESA                         ,    CDAREAGERE      ,
                          CDSUPERVISOR        ,   CDSEGMER                          ,    CDGOPERAC       ,
                          DSTIPOFATGER        ,   ANETLDRO                          ,    MEETLDRO        ,
                          BIETLDRO            ,   TRETLDRO                          ,    SEETLDRO        ,
                          VRFATMEDETLDRO      ,   VRFATLIQMEDDRO                    ,    VRIMPFATMEDDRO  ,
                          VRCONSETLDRO        ,   VRDESPETLDRO                      ,    VRMAOBETLDRO    ,
                          VRNFFATETLDRO       ,   VRFATLIQNFDRO                     ,    VRIMPFATNFDRO   ,
                          VRTARDRO            ,   VRTACDRO
                        )
                  VALUES
                        (
                          C_ETL.CDFILIAL      ,    C_ETL.CDEMPRESA                  ,   C_ETL.CDAREAGERE ,
                          C_ETL.CDSUPERVISOR  ,    C_ETL.CDSEGMER                   ,   C_ETL.CDGOPERAC  ,
                          V_TIPOFATU          ,    V_ANO                            ,   V_MES            ,
                          V_BIM               ,    V_TRI                            ,   V_SEM            ,
                          V_FATMEDICAO        ,    V_FATLIQ_MEDICAO                 ,   V_IMPOSTO_FAT_MED,
                          V_VRCONSUMOTOTAL    ,    V_DESPESASDIVER + V_DESPESAENTRA ,   V_DESPESAMAO     ,
                          V_FATNOTAFISCAL     ,    V_FATLIQ_NF                      ,   V_IMPOSTO_FAT_NF ,
                          V_VRTXTAR           ,    V_VRTXTAC
                        );

               V_CONT := V_CONT + 1;
               IF V_CONT >= 100 THEN
                  V_CONT := V_ZERO;
                  COMMIT;
               END IF; /* FIM COMMIT CADA 500 */

         END IF; /* FIM IF / CONFERE DTINICIALBI <= DTINICIO */
      END LOOP; /* FIM LOOP CURSOR C_ETL */
      COMMIT;
      V_DTINI := ADD_MONTHS(V_DTINI,1);
   END LOOP; /* FIM LOOP WHILE DATA/INI. DADTA/FIM */
END   ; /* FIM PROCEDURE */
