<?php
namespace Zeedhi\Queue;

abstract class Producer {

    /** @var string */
    protected static $queueName = null;
    /** @var Connection */
    protected $connection;
    /** @var array */
    protected $headers = array();

    public function __construct(Connection $connection) {
        $this->connection = $connection;
        if (static::$queueName === null) {
            throw Exception::missingProducerQueueName(get_class($this));
        }
    }

    public function send($message) {
        $this->connection->sendMessage(static::$queueName, $message, $this->headers);
    }
}